import java.lang.*;
import java.math.BigDecimal;
import java.math.BigInteger;

//--------------------------------------------------------------------//
/**
 * vZNX
 */
public class Calculate{

/** ̏ */
  public static final int MAX_DIGIT_COUNT=100000;

/** 1 s̕\ */
  public static final int LINE_DIGIT_COUNT=60;

/** ]ɌvZ錅 */
  public static final int COLLATERAL_DIGIT_COUNT=8;

/** 0 \ <code>BigDecimal</code> */
  public static final BigDecimal D0=new BigDecimal("0");

/** 1 \ <code>BigInteger</code> */
  public static final BigInteger I1=new BigInteger("1");

/** 1 \ <code>BigDecimal</code> */
  public static final BigDecimal D1=new BigDecimal("1");

/** 5<sup>2</sup> \ <code>BigDecimal</code> */
  public static final BigDecimal D25=new BigDecimal("25");

/** 16~5 \ <code>BigDecimal</code> */
  public static final BigDecimal D80=new BigDecimal("80");

/** 4~259 \ <code>BigDecimal</code> */
  public static final BigDecimal D956=new BigDecimal("956");

/** 239<sup>2</sup> \ <code>BigDecimal</code> */
  public static final BigDecimal D57121=new BigDecimal("57121");

/** bZ[Wpl */
  protected MessagePanel messagePanel;

/**
 * vZIuWFNg\z
 * @param messagePanel bZ[Wpl
 */
  public Calculate(MessagePanel messagePanel){
    this.messagePanel=messagePanel;
  }

//--------------------------------------------------------------------//
/**
 * ~ <i></i> vZ
 * @param n vZ錅
 */
  public void pi(int n){
    double coef=Math.log(25.0)/Math.log(10.0);
    int n2=(int)((double)n/coef)+1;
    int beginIndex=0;
    int endIndex=2+LINE_DIGIT_COUNT;

    messagePanel.clear();
    BigDecimal s=D0.setScale(n+COLLATERAL_DIGIT_COUNT);
    BigDecimal w=D80.setScale(n+COLLATERAL_DIGIT_COUNT);
    BigDecimal v=D956.setScale(n+COLLATERAL_DIGIT_COUNT);

    for(int i=0;i<n2;i++){
      w=w.divide(D25,BigDecimal.ROUND_HALF_EVEN);
      v=v.divide(D57121,BigDecimal.ROUND_HALF_EVEN);
      BigDecimal q=w.subtract(v);
      q=q.divide(new BigDecimal(String.valueOf(2*i+1)),
      	      	 BigDecimal.ROUND_HALF_EVEN);
      if((i%2)==0) s=s.add(q);
      else         s=s.subtract(q);
      if((int)(coef*(double)i)>=endIndex){
      	messagePanel.print(s.toString(),beginIndex,endIndex);
      	beginIndex=endIndex;
      	endIndex+=LINE_DIGIT_COUNT;
      }
    }
    while(beginIndex<n+2){
      messagePanel.print(s.toString(),beginIndex,endIndex);
      beginIndex=endIndex;
      endIndex+=LINE_DIGIT_COUNT;
    }
  }

//--------------------------------------------------------------------//
/**
 * Rΐ̒ <i>e</i> vZ
 * @param n vZ錅
 */
  public void exp(int n){
    double coef=Math.log(2.0)/Math.log(10.0);
    int beginIndex=0;
    int endIndex=2+LINE_DIGIT_COUNT;

    messagePanel.clear();
    BigDecimal s=D1.setScale(n+COLLATERAL_DIGIT_COUNT);
    BigDecimal w=D1.setScale(n+COLLATERAL_DIGIT_COUNT);
    BigInteger q=I1;

    int iter=0;
    int length=0;
    while(length<=n){
      iter++;
      length=(int)(coef*(double)(q.bitLength()-1));
      q=q.multiply(new BigInteger(String.valueOf(iter)));
      w=w.divide(new BigDecimal(String.valueOf(iter)),
      	      	 BigDecimal.ROUND_HALF_EVEN);
      s=s.add(w);
      if(length+2>=endIndex){
      	messagePanel.print(s.toString(),beginIndex,endIndex);
      	beginIndex=endIndex;
      	endIndex+=LINE_DIGIT_COUNT;
      }
    }
    while(beginIndex<n+2){
      messagePanel.print(s.toString(),beginIndex,endIndex);
      beginIndex=endIndex;
      endIndex+=LINE_DIGIT_COUNT;
    }
  }
}
